<?php

namespace FiloBlu\DisableShop\Observer;

use Magento\Framework\Event\Observer as EventObserver;
use Magento\Framework\Event\ObserverInterface;

class CatalogProductLoadAfter implements ObserverInterface {

    protected $_helper;

    public function __construct(
    \FiloBlu\DisableShop\Helper\Data $helper
    ) {
        $this->_helper = $helper;
    }

    public function execute(EventObserver $observer) {

        $product = $observer->getEvent()->getProduct();

        $_canDisableShop = $this->_helper->canDisableShop();
        $_canHidePrice = $this->_helper->canHidePrice();

        $_canDisableShopSingleProduct = ($_canDisableShop ? true : $product->getDisableShop());

        if ($_canDisableShopSingleProduct) {
            $product->setDisableAddToCart(true);
            //$product->setIsSalable(false); ????
        }

        $_canHidePriceSingleProduct = ($_canHidePrice ? true : $product->getHidePrice());

        if ($_canHidePriceSingleProduct) {
            $product->setCanShowPrice(false);
        }
    }

}
